# TP Loto

Énoncé du TP : [https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/](https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/)

## Question Loto 1 : Quels sont les signaux à renseigner dans la liste de sensibilité (si vous utilisez un process explicite) ?

La liste de sensibilité doit inclure tous les signaux dont la modification peut affecter le comportement du processus. Dans ce cas, il s'agit de : I_sel, I_0, I_1, I_2, I_3, I_4 et I_5.

## Question Loto 2 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ?

Si la liste des cas dans l’instruction case est incomplète et ne couvre pas toutes les combinaisons possibles de I_sel, cela peut entraîner un comportement indéterminé du circuit.
Si une entrée non prévue se produit, cela pose un problème, car cela peut entraîner des erreurs de conception ou des comportements imprévus.

## Question Loto 3 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.

La simulation n'est pas suffisante pour valider complètement le module parce que le testbench ne teste pas les cas qui vont dans when others, donc on ne sait pas si la sortie O_mux6 prendra bien la valeur "000000". Pour une validation complète, il faudrait inclure ces cas dans la simulation.

## Question Loto 4 : Quel(s) signal(aux) doit on renseigner dans la liste de sensibilité de ce processus séquentiel ? Pourquoi ?

Les signaux à inclure dans la liste de sensibilité sont I_clk et I_rst. I_rst est nécessaire car il est utilisé pour un reset asynchrone, et I_clk parce qu'il déclenche le processus avec rising_edge(I_clk). I_block n'a pas besoin d'être inclus, car il est évalué uniquement après le front montant de l'horloge.

## Question Loto 5 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ici ?

Si toutes les combinaisons d'entrée du module ne sont pas couvertes, ce ne sera pas
forcément grave, mais il est indispensable que les changements des signaux critiques soient présents dans le testbench.

## Question Loto 6 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.

C'est suffisant pour valider le module sur les points critiques, comme les changements des signaux de blocage et de réinitialisation, mais cela ne garantit pas une validation complète du fonctionnement global du module.

## Question Loto 7 : Combien de processus avez-vous décris ?

Un seul processus a été utilisé car le design est simple et de petite taille. Cependant, pour une machine d'états plus grande et complexe, il est recommandé d'utiliser trois processus afin de bien séparer la logique combinatoire de la logique séquentielle. Dans ce cas, cette séparation n'est pas explicite, car tout est inclus dans un seul processus.

Remarque : L'utilisation d'un seul processus peut entraîner la création involontaire de latches si tous les signaux ne sont pas assignées dans chaque branche du case.

## Question Loto 8 : De quel(s) type(s) sont-ils

C'est un processus séquentiel car il est synchronisé avec une horloge (I_clk). La mise à jour de l'état (SR_STATE) se fait sur le front montant de l'horloge, ce qui indique qu'il s'agit d'une logique séquentielle.

D'un autre côté, si nous utilisions trois processus, nous aurions :
•	Un processus séquentiel pour la mise à jour de l'état.
•	Un processus combinatoire pour la logique de transition entre les états.
•	Un autre processus combinatoire pour la génération des sorties en fonction de l'état actuel.

En conclusion, dans notre code, nous utilisons un seul processus séquentiel, car il gère à la fois la mémoire de l'état et la logique de sortie dans un même bloc.

## Question Loto 9 : Serait-il possible de décrire cette machine d'état de manière différente, en terme de nombre et de type de process ?

Oui, dans notre cas, nous utilisons un seul processus de type séquentiel (synchronisé). Cependant, la FSM peut également être décrite avec trois processus : le premier est un processus synchronisé utilisé pour mettre à jour le registre de l'état actuel avec la valeur de l'état futur. Le deuxième est un processus combinatoire utilisé pour calculer l'état futur en se basant sur l'état actuel. Le troisième est également un processus combinatoire utilisé pour calculer les valeurs des sorties en se basant uniquement sur l'état actuel dans le cas d'une FSM de Moore, ou sur l'état actuel et les entrées dans le cas d'une FSM de Mealy.

## Question Loto 10 : Ce test est-il concluant ? Justifiez.

Avec la simulation, nous pouvons valider l'automate ; cependant, les signaux rouge et verte ne peuvent pas être vérifiés par simulation, car ils utilisent une modulation PWM sur la carte.

## Question Loto 11 : Le circuit inféré par l’outil est-il conforme à l’attendu ? Sinon, en quoi diffère-t-il et est-ce lié à une erreur de description VHDL ?

Oui, le circuit correspond à ce qui était attendu. 

## Question Loto 12 : Quelles sont les ressources utilisées sur le FPGA ? En quelle quantité/proportion des ressources disponibles ? Des **LATCHES** sont-ils utilisés ? Est-ce positif ou pas, pourquoi ?

LUT as logic : 82
Register as flip flop : 89
Register as Latch : 0

Nous n’utilisons pas de latches parce que nous réalisons des circuits séquentiels et combinatoires. Il n’y a aucun latch, ce qui est positif, car s’il y en avait, cela signifierait qu’il y a une erreur dans notre code.


## Question Loto 13 : Le tirage est-il aléatoire pour un humain ? pour une machine ? Justifiez.

Pour l’humaine, c’est aléatoire, mais pour la machine, ce ne l’est pas, car elle peut compter le temps. 